function [ er, tan_perd ] = Funcion_Newton_bucle_for( er_opt, tan_perd_opt, er_ini, tan_perd_ini, delta_er, delta_tan_perd )

    vector_er = [];
    vector_tan = [];
    vector_coste = [];

    vector_s11_opt = [];
    vector_s11 = [];
    vector_s21_opt = [];
    vector_s21 = [];

for frecuencia =  3.3e9:0.1e9:4.9e9

    % Inicializacin de variables
    iteracion = 1;
    dC_er = 0.1;
    eta = 0.5;
    chi = 0.5;

    coste_act = 1;
    er_final = 0;
    tan_final = 0; 

    tan_perd = tan_perd_ini;
    er = er_ini;

    % Determinamos si tenemos prdidas o no
    if (tan_perd == 0)
        delta_tan = 0;
        dC_tan = 0;
        tan_final = 1;
    else
        delta_tan = delta_tan_perd;
        dC_tan = 0.1;
    end

    % Clculo de valores ptimos
    [s11_opt, s21_opt] = funcion_s(er_opt,tan_perd_opt,frecuencia);

    % Clculo de valores iniciales
    [s11_inc_er, s21_inc_er] = funcion_s(er+delta_er,tan_perd,frecuencia);
    [s11_inc_tan, s21_inc_tan] = funcion_s(er,tan_perd+delta_tan,frecuencia);
    [s11_reinc_er, s21_reinc_er] = funcion_s(er+2*delta_er,tan_perd,frecuencia);
    [s11_reinc_tan, s21_reinc_tan] = funcion_s(er,tan_perd+2*delta_tan,frecuencia);
    [s11, s21] = funcion_s(er,tan_perd,frecuencia);
    
    % Clculo de la diferencia entre el valor ptimo y el calculado
    diferencia_er = abs(er_opt-er);
    diferencia_tan = abs(tan_perd_opt-tan_perd);

    % Bucle de optimizacin     
    while (coste_act ~= 0) 

       % Evaluacin de la funcin coste
       coste_act = (abs(s11_opt-s11))*eta+(abs(s21_opt-s21))*chi;

       coste_inc_er = (abs(s11_opt-s11_inc_er))*eta+(abs(s21_opt-s21_inc_er))*chi;
       coste_reinc_er = (abs(s11_inc_er-s11_reinc_er))*eta+(abs(s21_inc_er-s21_reinc_er))*chi;
       dC_er = (coste_act-coste_inc_er)/delta_er;
       dC2_er = (coste_inc_er-coste_reinc_er)/delta_er;
       hessiano_er = (dC_er-dC2_er)/delta_er;

       coste_inc_tan = (abs(s11_opt-s11_inc_tan))*eta+(abs(s21_opt-s21_inc_tan))*chi;
       coste_reinc_tan = (abs(s11_inc_tan-s11_reinc_tan))*eta+(abs(s21_inc_tan-s21_reinc_tan))*chi;
       dC_tan = (coste_act-coste_inc_tan)/delta_tan;      
       dC2_tan = (coste_inc_tan-coste_reinc_tan)/delta_tan;
       hessiano_tan = (dC_tan-dC2_tan)/delta_tan;

        % Clculo del incremento de la tangente de prdidas
        if(tan_perd ~=0)
            if (diferencia_tan < 0.0009)
                dC_tan = 0;
                dC_tan_anterior = 0;
                tan_final = 1;
            else
                dC_tan = (coste_act-coste_inc_tan)/delta_tan;
            end
            tan_perd = tan_perd-(dC_tan/hessiano_tan);     
        end

        % Clculo del incremento de er
        if (diferencia_er < 0.1)
            dC_er = 0;
            dC_er_anterior = 0;
            er_final = 1;
        else
            dC_er = (coste_act-coste_inc_er)/delta_er;
        end
        er = er-(dC_er/hessiano_er);

        % Evaluacin de la diferencia de tangentes
        diferencia_tan = abs(tan_perd_opt-tan_perd);
        if (diferencia_tan < 0.0009)
            tan_final = 1;
        end

        % Evaluacin de la diferencia de er
        diferencia_er = abs(er_opt-er);
        if (diferencia_er < 0.1)
            er_final = 1;
        end

        % Clculo de los nuevos valores de los parmetros S    
        [s11_inc_er, s21_inc_er] = funcion_s(er+delta_er,tan_perd,frecuencia);
        [s11_inc_tan, s21_inc_tan] = funcion_s(er,tan_perd+delta_tan,frecuencia);
        [s11_reinc_er, s21_reinc_er] = funcion_s(er+2*delta_er,tan_perd,frecuencia);
        [s11_reinc_tan, s21_reinc_tan] = funcion_s(er,tan_perd+2*delta_tan,frecuencia);
        [s11, s21] = funcion_s(er,tan_perd,frecuencia);

        % Condicin de parada del algoritmo
        if (er_final == 1 && tan_final == 1)
            coste_act = (abs(s11_opt-s11))*eta+(abs(s21_opt-s21))*chi; % bucle for
            iteracion = iteracion+1;
            break
        end         

        % Incremento del contador de iteraciones
        iteracion = iteracion+1;

        % Nmero mximo de iteraciones
        if iteracion == 1000
            break
        end

    end
    
    vector_s11_opt = [vector_s11_opt s11_opt]
    vector_s11 = [vector_s11 s11]
    vector_s21_opt = [vector_s21_opt s21_opt]
    vector_s21 = [vector_s21 s21]
    vector_coste = [vector_coste coste_act];
    vector_tan = [vector_tan tan_perd];
    vector_er = [vector_er er];
    
end
    s21_opt_db = 20*log10(abs(vector_s21_opt));
    s21_db = 20*log10(abs(vector_s21));
    s11_opt_db = 20*log10(abs(vector_s11_opt));
    s11_db = 20*log10(abs(vector_s11));
    
    frecuencia =  3.3e9:0.1e9:4.9e9;
    
    % Representacin de resultados CASTELLANO
    figure, plot(frecuencia, s21_opt_db,'o-');
    hold on
    plot(frecuencia, s11_opt_db,'o-');
    plot(frecuencia, s21_db,'.-g');
    plot(frecuencia,s11_db,'.-g'); legend('S21 opt','S11 opt','S21','S11')
    xlabel('Frecuencia (Hz)')
    ylabel('Parmetros S (dB)')
%     title('Newton: Parmetros S (Sin prdidas, Bucle for)')
    title('Newton: Parmetros S (Con prdidas, Bucle for)')
    hold off

    figure, plot(frecuencia, vector_coste,'.-')
%     title('Newton: Evolucin del coste (Sin prdidas, Bucle for)');
    title('Newton: Evolucin del coste (Con prdidas, Bucle for)');
    xlabel('Frecuencia (Hz)')
    ylabel('Coste')

    figure, plot(frecuencia, vector_er,'.-')
%     title('Newton: Evolucin Er (Sin prdidas, Bucle for)')
    title('Newton: Evolucin Er (Con prdidas, Bucle for)')
    xlabel('Frecuencia (Hz)')
    ylabel('Er')

    figure, plot(frecuencia,vector_tan,'.-')
    title('Newton: Evolucin de la tangente (Con prdidas, Bucle for)');
    xlabel('Frecuencia (Hz)')
    ylabel('Tangente de prdidas')

%     % Representacin de resultados INGLES
%     figure, plot(frecuencia, s21_opt_db,'o-');
%     hold on
%     plot(frecuencia, s11_opt_db,'o-');
%     plot(frecuencia, s21_db,'.-g');
%     plot(frecuencia,s11_db,'.-g'); legend('S21 ideal','S11 ideal','S21','S11')
%     xlabel('Frequency (Hz)')
%     ylabel('S-Parameters (dB)')
%     title('Newton: S-Parameters (Simple permittivity, For Loop)')
% %     title('Newton: S-Parameters (Complex permittivity, For Loop)')
%     hold off
% 
%     figure,plot(frecuencia, vector_coste,'.-')
%     title('Newton: Cost Evolution (Simple permittivity, For Loop)');
% %     title('Newton: Cost Evolution (Complex permittivity, For Loop)');
%     xlabel('Frequency (Hz)')
%     ylabel('Cost')
% 
%     figure, plot(frecuencia, vector_er,'.-')
%     title('Newton: Er Evolution (Simple permittivity, For Loop)');
% %     title('Newton: Er Evolution (Complex permittivity, For Loop)');
%     xlabel('Frequency (Hz)')
%     ylabel('Er')
% 
% %     figure, plot(frecuencia, vector_tan,'.-')
% %     title('Newton: tan(delta) Evolution (Complex permittivity, For Loop)');
% %     xlabel('Frequency (Hz)')
% %     ylabel('Tan(delta)')  

end
