function [ s11,s21 ] = funcion_s( er,tan_perd,frecuencia )
% Datos conocidos
    a = 58.1e-3;
    d = 40e-3;
    c = 3e8;
    e0 = 8.85e-12; 
    mu0 = 4*pi*1e-7;
    w = 2*pi*frecuencia;
    er2= e0*er*(1-i*tan_perd);
    
    k0 = (2*pi*frecuencia)/c;
    gamma1 = sqrt((pi/a)^2-k0.^2);
    gamma1 = abs(real(gamma1))+i*abs(imag(gamma1));
    zc1 = i*w*mu0./gamma1;
        
    k = (w*sqrt(er2/e0))/c;
    gamma2 = sqrt((pi/a)^2-k.^2);
    gamma2 = abs(real(gamma2))+i*abs(imag(gamma2));
    zc2 = i*w*mu0./gamma2;
    
    Zin = zc2.*(zc1+zc2.*tanh(gamma2*d))./(zc2+zc1.*tanh(gamma2*d));
    ro_0 = (Zin-zc2)./(Zin+zc2);
    ro_d = (zc1-zc2)./(zc1+zc2);

    s11 = (Zin-zc1)./(Zin+zc1);
    s21 = ((1+s11).*(1+ro_d).*exp(-gamma2*d)./(1+ro_0));

end
